//
//  CASCBannerCallback.m
//  CleverAdsSolutions Construct
//
//  Copyright © 2020 Clever Ads Solutions. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CASCBannerCallback.h"

@implementation CASCBannerCallback

- (id) initWithCommandDelegate:(__weak id<CDVCommandDelegate>)myCommandDelegate withViewController:(UIViewController *)myViewController {
    self = [super init];
    if (self) {
        _commandDelegate = myCommandDelegate;
        _viewController = myViewController;
    }
    return self;
}

- (void) bannerAdViewDidLoad:(CASBannerView *)view {
    [self fireEventTrigger:@"_Loaded"];
}

- (void) bannerAdView:(CASBannerView *)adView didFailWith:(enum CASError)error {
    if (error == CASErrorNoFill || error == CASErrorReachedCap || error == CASErrorNoConnection || error == CASErrorManagerIsDisabled)
        [self fireEventTrigger:@"_LoadFailed"];
    else
        [self fireEventTrigger:@"_ShowFailed"];
}

- (void) bannerAdView:(CASBannerView *)adView willPresent:(id<CASStatusHandler>)impression {
    [self fireEventTrigger:@"_Shown"];
}

- (void) bannerAdViewDidRecordClick:(CASBannerView *)adView {
    [self fireEventTrigger:@"_Clicked"];
}

- (void)fireEventTrigger:(NSString *)event
{
    if (self.commandDelegate != nil) {
        NSString *result = [NSString stringWithFormat:@"%d", 0];
        result = [result stringByAppendingString:event];
        
        NSString *js = [NSString stringWithFormat:@"cordova.fireWindowEvent('%@')", result];
        [_commandDelegate evalJs:js];
    }
}
@end
